## freedv 1.4.3~1gdc71a1c

=== CMakeLists.txt ===
#
# FreeDV - HF Digital Voice for Radio Amateurs
#
# CMake configuration contributed by Richard Shaw (KF5OIM)
# Please report questions, comments, problems, or patches to the freetel
# mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
#

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

cmake_minimum_required(VERSION 2.8)

# Prevent in-source builds to protect automake/autoconf config.
# If an in-source build is attempted, you will still need to clean up a few
# files manually.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "   
   "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
   "separate build directory and run cmake from there.")
endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Set local module path.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(FreeDV)

# https://cmake.org/cmake/help/git-stage/policy/CMP0075.html
if(POLICY CMP0075)
    cmake_policy(SET CMP0075 NEW)
endif()

# Return the date (yyyy-mm-dd)
macro(DATE RESULT)
  execute_process(COMMAND "date" "+%Y%m%d" OUTPUT_VARIABLE ${RESULT})
endmacro()
DATE(DATE_RESULT)
string(REGEX REPLACE "\n$" "" DATE_RESULT "${DATE_RESULT}")
message(STATUS "Compilation date = XX${DATE_RESULT}XX")

#
# Set FreeDV version and generate src/version.h
#
set(FREEDV_VERSION_MAJOR 1)
set(FREEDV_VERSION_MINOR 4)
set(FREEDV_VERSION_PATCH 3)
set(FREEDV_VERSION_SUFFIX "devel")

set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
if(FREEDV_VERSION_PATCH)
    set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
endif()
if(FREEDV_VERSION_SUFFIX)
    set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
else()
    set(FREEDV_VERSION_STRING "${FREEDV_VERSION}")
endif()
message(STATUS "FreeDV version: ${FREEDV_VERSION_STRING}")
configure_file(cmake/version.h.in src/version.h @ONLY)

# Set default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug")
    message(STATUS "Build type not specified, defaulting to ${CMAKE_BUILD_TYPE}")
endif(NOT CMAKE_BUILD_TYPE)

# Work around for not using a svn working copy.
#add_definitions(-D_NO_AUTOTOOLS_)

#
# Find the git hash if this is a working copy.
#
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    find_package(Git QUIET)
    if(Git_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" describe --always HEAD
            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
            RESULT_VARIABLE res
            OUTPUT_VARIABLE FREEDV_HASH
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message(STATUS "freedv-gui current git hash: ${FREEDV_HASH}")
        add_definitions(-DGIT_HASH="${FREEDV_HASH}")
    else()
        message(WARNING "Git not found. Can not determine current commit hash.")
        add_definitions(-DGIT_HASH="Unknown")
    endif()
else()
        add_definitions(-DGIT_HASH="None")
endif()


# Set default build flags.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -std=c++11")
endif(APPLE)

#
# Setup cmake options
#
set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose makefile.")
set(USE_INTERNAL_CODEC2 FALSE CACHE BOOL
    "Download and build codec2 and lpcnetfreedv instead of using the system library.")
set(USE_STATIC_DEPS FALSE CACHE BOOL 
    "Download and build static libraries instead of system libraries.")
set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL 
    "Download and build static portaudio instead of the system library.")
set(USE_STATIC_SNDFILE FALSE CACHE BOOL
    "Download and build static sndfile instead of the system library.")
set(USE_STATIC_SAMPLERATE FALSE CACHE BOOL
    "Download and build static samplerate instead of the system library.")
set(USE_STATIC_SPEEXDSP FALSE CACHE BOOL
    "Download and build static speex instead of the system library.")
set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
    "Download and build static wxWidgets instead of the system library.")

if(USE_STATIC_DEPS)
    set(USE_STATIC_PORTAUDIO TRUE FORCE)
    set(USE_STATIC_SNDFILE TRUE FORCE)
    set(USE_STATIC_SAMPLERATE TRUE FORCE)
endif(USE_STATIC_DEPS)

#
# Pull in external wxWidgets target if performing static build.
#
if(BOOTSTRAP_WXWIDGETS)
    message(STATUS "Adding wxWidgets build target...")
    include(cmake/BuildWxWidgets.cmake)
endif(BOOTSTRAP_WXWIDGETS)

#
# Perform bootstrap build of wxWidgets
#
if(BOOTSTRAP_WXWIDGETS AND NOT EXISTS ${WXCONFIG})
    message(STATUS "Will perform bootstrap build of wxWidgets.
   After make step completes, re-run cmake and make again to perform FreeDV build.")
#
# Continue normal build if not bootstrapping wxWidgets or is already built.
#
else(BOOTSTRAP_WXWIDGETS AND NOT EXISTS ${WXCONFIG})


#
# Various hacks and work arounds for building under MinGW.
#
if(MINGW)
    message(STATUS "System is MinGW.")
    # Default to static build of portaudio until I can figure out why the
    # shared DLL doesn't work.
    set(USE_STATIC_PORTAUDIO TRUE)
    unset(USE_INTERNAL_CODEC2 CACHE)
    set(USE_INTERNAL_CODEC2 TRUE CACHE BOOL "Perform nternal buils of codec2 and lpcnetfreedv")
    # Setup HOST variables.
    include(cmake/MinGW.cmake)
    # This sets up the exe icon for windows under mingw.
    set(RES_FILES "")
    set(RES_FILES "${CMAKE_SOURCE_DIR}/contrib/freedv.rc")
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
        "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
    include(InstallRequiredSystemLibraries)
endif(MINGW)

# Math library is automatic on MinGW
if(UNIX)
    set(CMAKE_REQUIRED_INCLUDES math.h)
    set(CMAKE_REQUIRED_LIBRARIES m)
endif(UNIX)

# Find some standard headers and functions.
include(CheckIncludeFiles)
check_include_files("byteswap.h"   HAVE_BYTESWAP_H)
check_include_files("limits.h"     HAVE_LIMITS_H)
check_include_files("stddef.h"     HAVE_STDDEF_H)
check_include_files("stdlib.h"     HAVE_STDLIB_H)
check_include_files("string.h"     HAVE_STRING_H)
check_include_files("strings.h"    HAVE_STRINGS_H)
check_include_files("ltdl.h"       HAVE_LTDL_H)
check_include_files("inttypes.h"   HAVE_INTTYPES_H)
check_include_files("sys/stat.h"   HAVE_SYS_STAT_H)
check_include_files("sys/types.h"  HAVE_SYS_TYPES_H)

include(CheckTypeSize)
check_type_size("int" SIZEOF_INT)

include(CheckFunctionExists)
check_function_exists(floor HAVE_FLOOR)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(pow HAVE_POW)
check_function_exists(sqrt HAVE_SQRT)
check_function_exists(fseeko HAVE_FSEEKO)
check_function_exists(fmemopen HAVE_FMEMOPEN)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(vsnprintf HAVE_VSNPRINTF)

include(CheckSymbolExists)
check_symbol_exists("_fseeki64" "stdio.h" HAVE__FSEEKI64)

# fdmdv2_main.h requires patching to find config.h as it current looks in the
# source directory and the generated file goes in the binary directory.
configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                "${PROJECT_BINARY_DIR}/config.h" )
include_directories(${PROJECT_BINARY_DIR})

# Config file for bundled sox sources
configure_file("${PROJECT_SOURCE_DIR}/cmake/soxconfig.h.in"
               "${PROJECT_BINARY_DIR}/soxconfig.h")

# Pthread Library
# Actually not needed if compiling with c++11 or higher...
find_package(Threads REQUIRED)
message(STATUS "Threads library flags: ${CMAKE_THREAD_LIBS_INIT}")


#
# Find codec2 and lpcnetfreedv
#
if(CODEC2_BUILD_DIR)
    if(USE_INTERNAL_CODEC2)
        set(USE_INTERNAL_CODEC2 FALSE)
        message(WARNING "Use of build directories and internal builds are mutually exclusive. Forcing internal builds off.")
    endif()
    set(USE_INTERNAL_CODEC2 OFF CACHE BOOL "" FORCE)
    message(STATUS "Using codec2 from build directory...")
    find_package(codec2 REQUIRED
        NO_DEFAULT_PATH
        PATHS ${CODEC2_BUILD_DIR}
        CONFIGS codec2.cmake
    )
    if(LPCNET_BUILD_DIR)
        message(STATUS "Using LPCNet from build directory...")
        find_package(lpcnet REQUIRED
            NO_DEFAULT_PATH
            PATHS ${LPCNET_BUILD_DIR}
            CONFIGS lpcnetfreedv.cmake
        )
    else()
        message(FATAL_ERROR "Must use LPCNet from build directory if using codec2 from build directory.")
    endif()
elseif(USE_INTERNAL_CODEC2)
    message(STATUS "Will attempt internal build of codec2 and lpcnetfreedv.")
    include(cmake/BuildCodec2.cmake)
else(CODEC2_BUILD_DIR)
    message(STATUS "Looking for codec2...")
    # 'CONFIG' removed due to incompatibility with cmake version
    # in Ubuntu 12.04 (Precise) -- Stuart Longland
    find_package(codec2 QUIET)
    if(codec2_FOUND)
        get_target_property(CODEC2_LIBRARY codec2 LOCATION)
        get_target_property(CODEC2_INCLUDE_DIRS codec2 INTERFACE_INCLUDE_DIRECTORIES)
        message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
        message(STATUS "  codec2 headers: ${CODEC2_INCLUDE_DIRS}")
        find_package(lpcnetfreedv REQUIRED)
    else()
        # Try to find manually
        find_path(CODEC2_INCLUDE_DIRS codec2.h
                  PATH_SUFFIXES codec2)
        find_library(CODEC2_LIBRARY NAMES codec2)
        if(CODEC2_LIBRARY AND CODEC2_INCLUDE_DIRS)
            message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
            message(STATUS "  codec2 headers: ${CODEC2_INCLUDE_DIRS}")
            list(APPEND FREEDV_LINK_LIBS ${CODEC2_LIBRARY})
            include_directories(${CODEC2_INCLUDE_DIRS})
        else()
            message(FATAL_ERROR "codec2 library not found.
Linux: 
Codec2 may not be in your distribution so build yourself or use the cmake option to build internally.
Windws:
It's easiest to use the cmake option: USE_INTERNAL_CODEC2 or use build trees for codec2 and lpcnetfreedv."
        )
        endif()
    endif()
endif(CODEC2_BUILD_DIR)


#
# Find or build portaudio Library
#
if(NOT USE_STATIC_PORTAUDIO)
    message(STATUS "Looking for portaudio...")
    find_package(Portaudio REQUIRED)
    if(PORTAUDIO_FOUND)
        message(STATUS "  portaudio library: ${PORTAUDIO_LIBRARIES}")
        message(STATUS "  portaudio headers: ${PORTAUDIO_INCLUDE_DIRS}")
        list(APPEND FREEDV_LINK_LIBS ${PORTAUDIO_LIBRARIES})
        include_directories(${PORTAUDIO_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "portaudio library not found.
On Linux systems try installing:
    portaudio-devel  (RPM based systems)
    libportaudio-dev (DEB based systems)
On Windows it's easiest to use the cmake option: USE_STATIC_PORTAUDIO"
        )
    endif()
    if(NOT ${PORTAUDIO_VERSION} EQUAL 19 AND NOT MINGW)
        message(WARNING "Portaudio versions other than 19 are known to have issues. You have been warned!")
    endif()
else(NOT USE_STATIC_PORTAUDIO)
    message(STATUS "Will attempt static build of portaudio.")
    include(cmake/BuildPortaudio.cmake)
endif(NOT USE_STATIC_PORTAUDIO)

#
# Hamlib library
#
message(STATUS "Looking for hamlib...")
find_path(HAMLIB_INCLUDE_DIR hamlib/rig.h)
find_library(HAMLIB_LIBRARY hamlib PATH_SUFFIXES hamlib)
message(STATUS "  Hamlib library: ${HAMLIB_LIBRARY}")
message(STATUS "  Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
if(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
    message(STATUS "Hamlib library found.")
    include_directories(${HAMLIB_INCLUDE_DIR})
    list(APPEND FREEDV_LINK_LIBS ${HAMLIB_LIBRARY})
else(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
    message(FATAL_ERROR "hamlib not found.
On Linux systems try installing:
    hamlib-devel  (RPM based systems)
    libhamlib-dev (DEB based systems)"
    )
endif(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)


#
# Samplerate Library
#
if(NOT USE_STATIC_SAMPLERATE)
    message(STATUS "Looking for samplerate...")
    find_library(LIBSAMPLERATE samplerate)

=== src/CMakeLists.txt ===
set(FREEDV_SOURCES
    dlg_audiooptions.cpp
    dlg_filter.cpp
    dlg_options.cpp
    dlg_ptt.cpp
    dlg_plugin.cpp
    fdmdv2_main.cpp
    fdmdv2_pa_wrapper.cpp
    fdmdv2_plot.cpp
    fdmdv2_plot_scalar.cpp
    fdmdv2_plot_scatter.cpp
    fdmdv2_plot_spectrum.cpp
    fdmdv2_plot_waterfall.cpp
    hamlib.cpp
    serialport.cpp
    topFrame.cpp
    sox_biquad.c
    comp.h
    dlg_audiooptions.h
    dlg_filter.h
    dlg_options.h
    dlg_ptt.h
    fdmdv2_defines.h
    fdmdv2_main.h
    fdmdv2_pa_wrapper.h
    fdmdv2_plot.h
    fdmdv2_plot_scalar.h
    fdmdv2_plot_scatter.h
    fdmdv2_plot_spectrum.h
    fdmdv2_plot_waterfall.h
    hamlib.h
    sox_biquad.h
    sox/band.h
    sox/biquad.c
    sox/biquads.c
    sox/biquad.h
    sox/effects.c
    sox/effects.h
    sox/effects_i.c
    sox/formats_i.c
    sox/libsox.c
    sox/sox.h
    sox/sox_i.h
    sox/soxomp.h
    sox/util.h
    sox/xmalloc.h
    sox/xmalloc.c
    topFrame.h
    version.h
    osx_interface.h
)

set(FREEDV_SOURCES_OSX
    osx_interface.mm
)

set(FREEDV_LINK_LIBS_OSX
    "-framework AVFoundation"
)

# WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
# In addition, there are some required OSX-specific code files for platform specific handling.
if(APPLE)
    add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES} ${FREEDV_SOURCES_OSX})
else()
    add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES})
endif(APPLE)

# Link imported or build tree targets.
target_link_libraries(freedv codec2 lpcnetfreedv)

# Add build dependencies for interally built external libraries.
if(USE_INTERNAL_CODEC2)
    add_dependencies(freedv build_codec2 build_lpcnetfreedv)
endif()

# Add depenencies for other statically built libraries, if applicable.
if(FREEDV_STATIC_DEPS)
    add_dependencies(freedv ${FREEDV_STATIC_DEPS})
endif(FREEDV_STATIC_DEPS)

# Link other dependencies
if(APPLE)
target_link_libraries(freedv ${FREEDV_LINK_LIBS} ${FREEDV_LINK_LIBS_OSX})
else()
target_link_libraries(freedv ${FREEDV_LINK_LIBS})
endif(APPLE)

# For older Xcode (< 9.0), bypass usage of @available.
if(APPLE)
if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
add_definitions(-DAPPLE_OLD_XCODE)
endif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
endif(APPLE)

# Insert source and generated header directories before other search directories.
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS freedv
    RUNTIME DESTINATION bin
)

# Custom commands to build OSX images.
if(APPLE)
    add_custom_command(
        TARGET freedv
        POST_BUILD
        COMMAND rm ARGS -rf FreeDV.* dist_tmp
        COMMAND mkdir ARGS -p FreeDV.app/Contents/MacOS
        COMMAND mkdir ARGS -p FreeDV.app/Contents/Resources/English.lproj
        COMMAND cp ARGS ${CMAKE_CURRENT_BINARY_DIR}/info.plist FreeDV.app/Contents
        COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/freedv.icns FreeDV.app/Contents/Resources
        COMMAND echo ARGS -n "APPL????" > FreeDV.app/Contents/PkgInfo
        COMMAND cp ARGS freedv FreeDV.app/Contents/MacOS/FreeDV
        COMMAND DYLD_LIBRARY_PATH=${CODEC2_BUILD_DIR}/src:${LPCNET_BUILD_DIR}/src:${DYLD_LIBRARY_PATH} ${CMAKE_SOURCE_DIR}/macdylibbundler/dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @loader_path/../libs/
        COMMAND mkdir dist_tmp
        COMMAND cp -r FreeDV.app dist_tmp
        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO -fs HFS+ ./FreeDV.dmg
        COMMAND rm -rf dist_tmp
    )
endif(APPLE)

=== debian/changelog ===
freedv (1.4.3~1gdc71a1c-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Use https homepage.
  * Add debian/gitlab-ci.yml.
  * Update description. (Closes: #935795)

  [ A. Maitland Bottoms ]
  * update to 1.4.3 using dc71a1c pending upstream release
  * update standards-version
  * Add upstream/metadata

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Oct 2020 15:26:20 -0400

=== debian/control ===
Source: freedv
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       libcodec2-dev (>= 0.9),
               libhamlib-dev,
               libsamplerate-dev,
               libsndfile-dev,
               libspeexdsp-dev,
               libwxgtk3.0-gtk3-dev,
               portaudio19-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://freedv.org/
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/freedv.git

Package: freedv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Digital Voice mode for ham radio
 FreeDV is a digital voice mode intended for transmission and
 reception over high-frequency (HF) radio. It uses a frequency
 division multiplex (FDM) modem with 15 carriers and no forward error
 correction (FEC). A low bit-rate voice coder-decoder (Codec 2)
 provides voice quality without the listener fatigue caused by noise
 and interference normally associated with analog single sideband
 (SSB) voice. A HF SSB transceiver, personal computer and two sound
 cards are required. Path simulation and on-the-air HF testing have
 shown that decoding voice is possible at a signal-to-noise ratio of
 4 dB.
 .
 The FreeDV software was developed by David Rowe (Codec 2, FDM
 modem implementation, integration) and David Witten (GUI,
 architecture design). The FreeDV design and user interface was based
 on the earlier FDMDV program which was developed by Francesco
 Lanza. The FDM modem design and development was supported from Peter
 Martinez.

=== debian/rules ===
#!/usr/bin/make -f
VER=$(shell dpkg-parsechangelog -ldebian/changelog | sed -rne 's,^Version: (.*),\1,p')
export VER

%:
	dh $@ --builddir=Build --build-system=cmake

override_dh_auto_configure:
	dh_auto_configure --builddirectory=Build --buildsystem=cmake -- -DDEB_VERSION=$(VER) -DCMAKE_BUILD_TYPE=Debug -DUSE_STATIC_CODEC2=False -DUSE_STATIC_SPEEXDSP=False

false_override_dh_auto_install:
	dh_auto_install
	/usr/bin/install --mode=0644 -D contrib/freedv.desktop debian/freedv/usr/share/applications/freedv.desktop
	for r in 48x48 64x64 128x128 256x256 ; do /usr/bin/install --mode=0644 -D contrib/freedv$$r.png debian/freedv/usr/share/icons/hicolor/$$r/apps/freedv.png ; done

## freedv 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 # mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
 #
 
-set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")
-
-cmake_minimum_required(VERSION 2.8)
+set(CMAKE_OSX_DEPLOYMENT_TARGET "10.11" CACHE STRING "Minimum OS X deployment version")
+
+cmake_minimum_required(VERSION 3.0)
 
 # Prevent in-source builds to protect automake/autoconf config.
 # If an in-source build is attempted, you will still need to clean up a few
@@ -16,7 +16,7 @@
 set(CMAKE_DISABLE_SOURCE_CHANGES ON)
 set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
 if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
-  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "   
+  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
    "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
    "separate build directory and run cmake from there.")
 endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
@@ -25,6 +25,11 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
 project(FreeDV)
+
+# Build universal ARM64 and x86_64 binaries on Mac.
+if(BUILD_OSX_UNIVERSAL)
+set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
+endif(BUILD_OSX_UNIVERSAL)
 
 # https://cmake.org/cmake/help/git-stage/policy/CMP0075.html
 if(POLICY CMP0075)
@@ -43,14 +48,11 @@
 # Set FreeDV version and generate src/version.h
 #
 set(FREEDV_VERSION_MAJOR 1)
-set(FREEDV_VERSION_MINOR 4)
-set(FREEDV_VERSION_PATCH 3)
-set(FREEDV_VERSION_SUFFIX "devel")
-
-set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
-if(FREEDV_VERSION_PATCH)
-    set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
-endif()
+set(FREEDV_VERSION_MINOR 7)
+set(FREEDV_VERSION_PATCH 0)
+set(FREEDV_VERSION_SUFFIX "")
+
+set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR}.${FREEDV_VERSION_PATCH})
 if(FREEDV_VERSION_SUFFIX)
     set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
 else()
@@ -105,9 +107,9 @@
 set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose makefile.")
 set(USE_INTERNAL_CODEC2 FALSE CACHE BOOL
     "Download and build codec2 and lpcnetfreedv instead of using the system library.")
-set(USE_STATIC_DEPS FALSE CACHE BOOL 
+set(USE_STATIC_DEPS FALSE CACHE BOOL
     "Download and build static libraries instead of system libraries.")
-set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL 
+set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL
     "Download and build static portaudio instead of the system library.")
 set(USE_STATIC_SNDFILE FALSE CACHE BOOL
     "Download and build static sndfile instead of the system library.")
@@ -117,6 +119,8 @@
     "Download and build static speex instead of the system library.")
 set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
     "Download and build static wxWidgets instead of the system library.")
+set(USE_PULSEAUDIO FALSE CACHE BOOL
+    "Use PulseAudio instead of PortAudio for audio I/O.")
 
 if(USE_STATIC_DEPS)
     set(USE_STATIC_PORTAUDIO TRUE FORCE)
@@ -201,7 +205,7 @@
 include(CheckSymbolExists)
 check_symbol_exists("_fseeki64" "stdio.h" HAVE__FSEEKI64)
 
-# fdmdv2_main.h requires patching to find config.h as it current looks in the
+# main.h requires patching to find config.h as it current looks in the
 # source directory and the generated file goes in the binary directory.
 configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                 "${PROJECT_BINARY_DIR}/config.h" )
@@ -268,7 +272,7 @@
             include_directories(${CODEC2_INCLUDE_DIRS})
         else()
             message(FATAL_ERROR "codec2 library not found.
-Linux: 
+Linux:
 Codec2 may not be in your distribution so build yourself or use the cmake option to build internally.
 Windws:
 It's easiest to use the cmake option: USE_INTERNAL_CODEC2 or use build trees for codec2 and lpcnetfreedv."
@@ -279,15 +283,19 @@
 
 
 #
-# Find or build portaudio Library
-#
-if(NOT USE_STATIC_PORTAUDIO)
+# Find or build portaudio/PulseAudio Library
+#
+if(NOT USE_STATIC_PORTAUDIO AND NOT USE_PULSEAUDIO)
     message(STATUS "Looking for portaudio...")
-    find_package(Portaudio REQUIRED)
+    find_package(portaudio-2.0 REQUIRED)
     if(PORTAUDIO_FOUND)
         message(STATUS "  portaudio library: ${PORTAUDIO_LIBRARIES}")
         message(STATUS "  portaudio headers: ${PORTAUDIO_INCLUDE_DIRS}")
+        if(pkgcfg_lib_PORTAUDIO_portaudio)
+        list(APPEND FREEDV_LINK_LIBS ${pkgcfg_lib_PORTAUDIO_portaudio})
+        else(pkgcfg_lib_PORTAUDIO_portaudio)
         list(APPEND FREEDV_LINK_LIBS ${PORTAUDIO_LIBRARIES})
+        endif(pkgcfg_lib_PORTAUDIO_portaudio)
         include_directories(${PORTAUDIO_INCLUDE_DIRS})
     else()
         message(FATAL_ERROR "portaudio library not found.
@@ -300,35 +308,20 @@
     if(NOT ${PORTAUDIO_VERSION} EQUAL 19 AND NOT MINGW)
         message(WARNING "Portaudio versions other than 19 are known to have issues. You have been warned!")
     endif()
-else(NOT USE_STATIC_PORTAUDIO)
-    message(STATUS "Will attempt static build of portaudio.")
-    include(cmake/BuildPortaudio.cmake)
-endif(NOT USE_STATIC_PORTAUDIO)
-
-#
-# Hamlib library
-#
-message(STATUS "Looking for hamlib...")
-find_path(HAMLIB_INCLUDE_DIR hamlib/rig.h)
-find_library(HAMLIB_LIBRARY hamlib PATH_SUFFIXES hamlib)
-message(STATUS "  Hamlib library: ${HAMLIB_LIBRARY}")
-message(STATUS "  Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
-if(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-    message(STATUS "Hamlib library found.")
-    include_directories(${HAMLIB_INCLUDE_DIR})
-    list(APPEND FREEDV_LINK_LIBS ${HAMLIB_LIBRARY})
-else(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-    message(FATAL_ERROR "hamlib not found.
+elseif(USE_PULSEAUDIO)
+    message(STATUS "Finding PulseAudio...")
+    find_package(PulseAudio REQUIRED)
+    if(PULSEAUDIO_FOUND)
+        message(STATUS "  PulseAudio library: ${PULSEAUDIO_LIBRARY}")
+        message(STATUS "  PulseAudio headers: ${PULSEAUDIO_INCLUDE_DIR}")
+        list(APPEND FREEDV_LINK_LIBS ${PULSEAUDIO_LIBRARY})
+        include_directories(${PULSEAUDIO_INCLUDE_DIR})
+        add_definitions(-DAUDIO_ENGINE_PULSEAUDIO_ENABLE)
+    else()
+        message(FATAL_ERROR "PulseAudio library not found.
 On Linux systems try installing:
-    hamlib-devel  (RPM based systems)
-    libhamlib-dev (DEB based systems)"
-    )
-endif(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-
-
-#
-# Samplerate Library
-#
-if(NOT USE_STATIC_SAMPLERATE)
-    message(STATUS "Looking for samplerate...")
-    find_library(LIBSAMPLERATE samplerate)
+    pulseaudio-libs-devel  (RPM based systems)
+    libpulse-dev           (DEB based systems)
+")
+     endif()
+else()

=== src/CMakeLists.txt ===
set(FREEDV_SOURCES
    dlg_audiooptions.cpp
    dlg_filter.cpp
    dlg_options.cpp
    dlg_ptt.cpp
    main.cpp
    plot.cpp
    plot_scalar.cpp
    plot_scatter.cpp
    plot_spectrum.cpp
    plot_waterfall.cpp
    hamlib.cpp
    serialport.cpp
    topFrame.cpp
    sox_biquad.c
    comp.h
    dlg_audiooptions.h
    dlg_filter.h
    dlg_options.h
    dlg_ptt.h
    defines.h
    main.h
    plot.h
    plot_scalar.h
    plot_scatter.h
    plot_spectrum.h
    plot_waterfall.h
    hamlib.h
    sox_biquad.h
    sox/band.h
    sox/biquad.c
    sox/biquads.c
    sox/biquad.h
    sox/effects.c
    sox/effects.h
    sox/effects_i.c
    sox/effects_i_dsp.c
    sox/fft4g.c
    sox/formats.c
    sox/formats_i.c
    sox/libsox.c
    sox/sox.h
    sox/sox_i.h
    sox/soxomp.h
    sox/util.c
    sox/util.h
    sox/vol.c
    sox/xmalloc.h
    sox/xmalloc.c
    topFrame.h
    version.h
    osx_interface.h
    pskreporter.cpp
    pskreporter.h
    udp.cpp
    util.cpp
    eq.cpp
    voicekeyer.cpp
    playrec.cpp
    ongui.cpp
    freedv_interface.cpp
    freedv_interface.h        
)

set(FREEDV_SOURCES_OSX
    osx_interface.mm
)

set(FREEDV_LINK_LIBS_OSX
    "-framework AVFoundation"
)

# Compile FreeDV components
add_subdirectory(audio)

# WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
# In addition, there are some required OSX-specific code files for platform specific handling.
if(APPLE)
    set(RES_FILES freedv.icns)
    set_source_files_properties(freedv.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(FreeDV MACOSX_BUNDLE ${FREEDV_SOURCES} ${RES_FILES} ${FREEDV_SOURCES_OSX})
    set_target_properties(FreeDV PROPERTIES
        BUNDLE True
        MACOSX_BUNDLE_GUI_IDENTIFIER org.freedv.freedv
        MACOSX_BUNDLE_BUNDLE_NAME FreeDV
        MACOSX_BNUDLE_COPYRIGHT "Copyright (c) 2021 FreeDV"
        MACOSX_BUNDLE_BUNDLE_VERSION "${FREEDV_VERSION}"
        MACOSX_BUNDLE_BUNDLE_SHORT_VERSION_STRING "${FREEDV_VERSION}"
        MACOSX_BUNDLE_BUNDLE_LONG_VERSION_STRING "${FREEDV_VERSION}"
        MACOSX_BUNDLE_ICON_FILE "freedv"
        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/src/info.plist.in
    )
else()
    add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES})
endif(APPLE)

# Link imported or build tree targets.
if(APPLE)
target_link_libraries(FreeDV codec2 lpcnetfreedv fdv_audio)
else(APPLE)
target_link_libraries(freedv codec2 lpcnetfreedv fdv_audio)
endif(APPLE)

# Add build dependencies for interally built external libraries.
if(USE_INTERNAL_CODEC2)
    add_dependencies(freedv build_codec2 build_lpcnetfreedv)
endif()

# Add depenencies for other statically built libraries, if applicable.
if(FREEDV_STATIC_DEPS)
    if(APPLE)
    add_dependencies(FreeDV ${FREEDV_STATIC_DEPS})
    else(APPLE)
    add_dependencies(freedv ${FREEDV_STATIC_DEPS})
    endif(APPLE)
endif(FREEDV_STATIC_DEPS)

# Link other dependencies
if(APPLE)
target_link_libraries(FreeDV ${FREEDV_LINK_LIBS} ${FREEDV_LINK_LIBS_OSX})
elseif(WIN32)
target_link_libraries(freedv ${FREEDV_LINK_LIBS} ws2_32)
else()
target_link_libraries(freedv ${FREEDV_LINK_LIBS})
endif(APPLE)

# For older Xcode (< 9.0), bypass usage of @available.
if(APPLE)
if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
add_definitions(-DAPPLE_OLD_XCODE)
endif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
endif(APPLE)

# Insert source and generated header directories before other search directories.
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(APPLE)
install(TARGETS FreeDV
    BUNDLE DESTINATION bin
)
else(APPLE)
install(TARGETS freedv
    RUNTIME DESTINATION bin
)
endif(APPLE)

# Custom commands to build OSX images.
if(APPLE)
    add_custom_command(
        TARGET FreeDV
        POST_BUILD
        COMMAND rm -rf dist_tmp FreeDV.dmg || true
        COMMAND DYLD_LIBRARY_PATH=${CODEC2_BUILD_DIR}/src:${LPCNET_BUILD_DIR}/src:${DYLD_LIBRARY_PATH} ${CMAKE_SOURCE_DIR}/macdylibbundler/dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @loader_path/../libs/ -i /usr/lib -s ${LPCNET_BUILD_DIR}/src -s ${CODEC2_BUILD_DIR}/src 
        COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/freedv.icns FreeDV.app/Contents/Resources
        COMMAND mkdir dist_tmp
        COMMAND cp -r FreeDV.app dist_tmp
        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO -fs HFS+ ./FreeDV.dmg
        COMMAND rm -rf dist_tmp
    )
endif(APPLE)

=== src/audio/CMakeLists.txt ===
if(USE_PULSEAUDIO)
set(AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES
    PulseAudioDevice.cpp
    PulseAudioEngine.cpp
    )

else(USE_PULSEAUDIO)
set(AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES
    PortAudioDevice.cpp
    PortAudioEngine.cpp
    )

endif(USE_PULSEAUDIO)

add_library(fdv_audio STATIC
    AudioDeviceSpecification.cpp
    AudioEngineFactory.cpp
    IAudioDevice.cpp
    IAudioEngine.cpp
    ${AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES}
)

=== debian/changelog ===
freedv (1.7.0-1) unstable; urgency=medium

  * New upstream release.
    Pulseaudio support

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Feb 2022 11:19:49 -0500

freedv (1.6.1-2) unstable; urgency=medium

  * upload to master since codec2 1.0.1 is already there.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 07 Dec 2021 20:05:58 -0500

freedv (1.6.1-1) experimental; urgency=medium

  * New upstream release.
  * build without buggy AVX instruction test

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 10 Nov 2021 23:11:11 -0500

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                debhelper-compat (= 13),
 	       libcodec2-dev (>= 0.9),
                libhamlib-dev,
+	       libpulse-dev,
                libsamplerate-dev,
                libsndfile-dev,
                libspeexdsp-dev,

## freedv 1.8.2

=== debian/changelog ===
freedv (1.8.2-1) unstable; urgency=medium

  [ Daniele Forsi ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Update standards version to 4.6.0, no changes needed.

  [ A. Maitland Bottoms ]
  * New upstream release.
  * Update standards version to 4.6.1, no changes needed.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 13 Aug 2022 15:23:50 -0400

freedv (1.7.0-2) unstable; urgency=medium

  * Actually Enable building with pulseaudio (Thanks wolfgang!)
    (Closes: #1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 28 Mar 2022 20:28:17 -0400

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-	       libcodec2-dev (>= 0.9),
+               libcodec2-dev (>= 0.9),
                libhamlib-dev,
-	       libpulse-dev,
+               libpulse-dev,
                libsamplerate-dev,
                libsndfile-dev,
                libspeexdsp-dev,
                libwxgtk3.0-gtk3-dev,
                portaudio19-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://freedv.org/
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddir=Build --build-system=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	 -DDEB_VERSION=$(DEB_VERSION) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUSE_STATIC_CODEC2=False \
	 -DUSE_STATIC_SPEEXDSP=False -DDUSE_PULSEAUDIO=True

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/freedv/usr/share/freedv-gui
